int check_daily_limit(char *name, int online_time, int time_allowed);

int free_lines()    /* returns the number of free dial-in lines */
{
  int line_count = 0;
  struct utmp *upp;
  
  /* count up number of ttyS devices */
  setutent();
  while ((upp = getutent()) != (struct utmp *) NULL)
    if ((upp->ut_type == USER_PROCESS) && (upp->ut_line[3] == 'S'))
      ++line_count;
/*  printf("Lines in use %d\n", line_count); */
  return(NO_OF_LINES - line_count);
}

int time_permitted(char *name)  /* returns a users time per call */
{
  FILE *fp;
  char record_name[9];
  int time_per_call;

  /* fetch a user record from dialin.users */
  if (!(fp = fopen("/usr/etc/dialin.users", "r")))
  {                   /* if the file can't be opened then    */
    fclose(fp);       /* use a default time limit            */
    return(DEFAULTTIME);
  }
  while(1)     /* continue until name found or can't read */
  {            /* anymore names from file                 */
    if (fscanf(fp, "%s %d", record_name, &time_per_call) != 2)
    {                          /* got to end without finding name */
      fclose(fp);              /* name not in the dialin.users    */
      return(DEFAULTTIME);     /* file so use default time limit  */
    }
    if (!strcmp(name, record_name))
    {   /* found the users record in the file */
      fclose(fp);
      return(time_per_call);
    }
  }
}

int check_daily_limit(char *name, int online_time, int time_allowed)
{
  /* returns zero if passed the check 1 if failed (ie over limit) */

  int tl;
  struct user_time_record
  {
    char name[9];
    int  time;
  };
  int num_read;

  struct user_time_record user_time;

  /* open the users daily time file */
  if ((tl = open("/usr/etc/user_times", O_RDWR)) == -1)
  {
    printf("unable to open user_times file\n\r");
    tl = creat("/usr/etc/user_times", 0600);
    close(tl);
    if ((tl = open("/usr/etc/user_times", O_RDWR)) == -1) 
      return(0); /* problem opening it so just bail */
  }

  /* locate the users name in the file */
 
  num_read = read(tl, &user_time, sizeof(user_time)); 
  while(num_read == sizeof(user_time)) /* continue until name found or can't read */
  {            
    if (!strcmp(name, user_time.name))
    {   /* found the users record in the file */
      /* update the record first */
      lseek(tl, -sizeof(user_time), 1);
      if (online_time < 5)
        user_time.time += online_time;
      else
        user_time.time += 5;  
      write(tl, &user_time, sizeof(user_time));
      close(tl);

      /* now do the checking */
      if (user_time.time > (time_allowed * 2))
        return(1); /* failed the check */
      else
        return(0);
    }
    num_read = read(tl, &user_time, sizeof(user_time));
  }
  /* got to end without finding it so create it */
  printf("New entry %s \n\r", name);
  user_time.time = online_time;
  strcpy(user_time.name, name);
  write(tl, &user_time, sizeof(user_time));
  close(tl);
  return(0);
}
