#include <stdio.h>
#include <fcntl.h>
#include <time.h>

#define MINS_IN_DAY 1440
#define MINS_IN_LIMIT_PERIOD 480
#define OFF_PEAK_MINS 960
#define NUM_LINES   6
#define DIVIDER 8640

main(int argc, char *argv[])
{
  int mins_today;
  int utilisation;
  int total_time = 0;
  int count = 0;
  int fp;
  int num_read;
  struct tm *lt;
  time_t now_time;
  char fname[50];
  int len;
 
  struct rec
  {
    char name[9];
    int time;
  };
  struct rec tr;

  now_time = time((time_t *)0);
  lt = localtime(&now_time);
  
  strcpy(fname, "/usr/etc/user_times");

  if (argc == 2)
  {
    strcat(fname, ".");
    len = strlen(fname);
    fname[len] = *argv[1];
    fname[len+1] = '\0';
  }

/*  printf("%s\n", fname); */
  if (argc == 2)
    mins_today = 24 * 60;
  else
    mins_today = lt->tm_min + (lt->tm_hour * 60) - OFF_PEAK_MINS;
  if ((fp = open(fname, O_RDONLY)) == -1)
  {
    printf("No daily limits file\n\r\n\r");
  }
  else
  {
    num_read = read(fp, &tr, sizeof(tr));
    while (num_read == sizeof(tr))
    {
      ++count;
      total_time += tr.time;
      printf("%-9s %d\n", tr.name, tr.time);
      num_read = read(fp, &tr, sizeof(tr));
    }
    utilisation = (total_time*100) / (mins_today * NUM_LINES);
    printf("Current time %02d:%02d\n", lt->tm_hour, lt->tm_min);
    printf("Total online time %d\n", total_time);
    printf("Line utilisation %d\%%\n", utilisation);
    printf("Total records = %d\n\r", count);
    close(fp);
  }
}
